<?
  // Byte-CPU-meter v0.1
  // Programado por Manz
  //
  // Licencia Creative Commons (http://creativecommons.org/licenses/by-nc-sa/3.0/deed.es_CL)
  // (25122007): v0.1
  // (25122007): Aadida posibilidad de cambiar colores / deshabilitar logo

  // Muestra a Byte en la parte izquierda
  // 1 ~ Activado (por defecto)
  // 0 ~ Desactivado
  define("VIEWBYTE", 1);
  
  // Color de fondo de la barra de progreso (defecto: gris)
  define("COLOR_BARRA_FONDO", "EEE");
  
  // Valores UPTIME (load average) para los estados de CPU
  // Valores predefinidos para servidores compartidos (Dreamhost, Servage, ...)
  define("1",0.60);  // Idle
  define("2",2.60);  // Light
  define("3",4.60);  // Work
  define("4",6.60);  // Occupied
  define("5",8.60);  // Heavy
  
  // Valores predefinidos para servidores virtualizados o dedicados
  // define("1",0.20);  // Idle
  // define("2",1.00);  // Light
  // define("3",2.00);  // Work
  // define("4",4.00);  // Occupied
  // define("5",6.00);  // Heavy
  
  // Obtenemos el LOAD AVERAGE del ultimo minuto
  $uptime = shell_exec("uptime");
  $uptime = substr($uptime,(strpos($uptime,"average:") + 8));
  $uptime = substr($uptime,0,strpos($uptime,","));
  
  // Pixels de la barra medidora
  $b = round(($uptime * 100) / constant("5"),0);
  
  // Establecemos los datos del medidor (id de estado y color)
  switch (1) {
    case ($uptime < constant("1")):
      define("ID", 1);
      $col = "04a900";
      break;
    case ($uptime < constant("2")):
      define("ID", 2);
      $col = "d6d900";
      break;
    case ($uptime < constant("3")):
      define("ID", 3);
      $col = "ffde00";
      break;
    case ($uptime < constant("4")):
      define("ID", 4);
      $col = "ffa200";
      break;            
    default:
      define("ID", 5);
      $col = "FF0000";
      $b = 100;
      break;
  }
  
  // Si mostramos el logo, hacemos espacio (margen)
  if (constant("VIEWBYTE")) {
    echo "<img src=\"byte" . constant("ID") . ".gif\" alt=\"Byte-CPU-Meter\" align=\"left\" />\r";
    define("ML",36);
  }
  else
    define("ML",0);

  echo "  <div style=\"font-size:8px;margin-left:" . constant("ML") . "px;height:10px;border:1px solid #999;background:#" . constant("COLOR_BARRA_FONDO") . ";width:100px\" title=\"$uptime\"><div style=\"height:10px;background:#${col};width:${b}px\" title=\"$uptime\"></div></div>";
  echo "<span style=\"font-size:x-small\"><a href=\"http://www.emezeta.com/articulos/byte-cpu-meter-mide-la-carga-de-tu-servidor\">Byte-CPU-Meter</a> por <a href=\"http://www.emezeta.com/\">Manz</a></span>";
?>